    #include <stdio.h>
    #include <stdlib.h>
    #include <unistd.h>
    #include <errno.h>
    #include <string.h>
    #include <sys/types.h>
    #include <sys/time.h>
    #include <sys/socket.h>
    #include <netinet/in.h>
    #include <arpa/inet.h>
    #include <time.h>
  
  
     #include <signal.h>

  
    #define MYPORT 4950    // the port users will be connecting to

    #define MAXBUFLEN 1500


    volatile sig_atomic_t global_num = 0; /* gloabal variable */

    void timer_interrupt(int num)
    {
                
        global_num = ! global_num; 
        alarm (1);
        signal(SIGALRM, timer_interrupt);
        //printf("Timer interrupt %d\n",m++);
     }


  
    int main(void)
    {
    
    	int bytes_rx_total;
    	int tmp;
	float rate;
	
	FILE *f1;
                             	

       int k;
       int sockfd;
       struct sockaddr_in my_addr;    // my address information
       struct sockaddr_in their_addr; // connector's address information
       int addr_len, numbytes;
       char buf[MAXBUFLEN]; // this is used for receiving packers
       //char signalling[20]; // this is to store START message

       char * addr_string = "10.0.0.1";
       //just initialize, no special meaning 
     	int test_end; 
	
 
       /*adding select for non-blocking purpose */
       int fd_max;
       fd_set read_fds; 
       struct timeval tv;
 
 
      
       FD_ZERO(&read_fds);   // clear the master and temp sets
       
      
      
	/*------Sever Started
	wait for slaves begin test-peration
	test prepare will be cost 1 sec.
	then begin receiving packets and make statistics */

        if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
            perror("socket");
            exit(1);
        }

        my_addr.sin_family = AF_INET;         // host byte order
        my_addr.sin_port = htons(MYPORT);     // short, network byte order
        my_addr.sin_addr.s_addr = INADDR_ANY; // automatically fill with my IP
        memset(&(my_addr.sin_zero), '\0', 8); // zero the rest of the struct

        if (bind(sockfd, (struct sockaddr *)&my_addr,sizeof(struct sockaddr)) == -1)
	 {
            perror("bind");
            exit(1);
        }

	printf ( " A Datagram Server is runnning on this node !\n Waiting for packets ....\n ");
	
       /* herie, the node is waiting for a message from sending STA */
       /* it includes a START signal and the test duration */	
	
      	addr_len = sizeof(struct sockaddr);
       if ((numbytes=recvfrom(sockfd,buf, MAXBUFLEN-1, 0,
                           (struct sockaddr *)&their_addr, (socklen_t*)&addr_len)) == -1)
		 	{
 	           		perror("recvfrom");
		 	           exit(1);
 	      		 }



        /* extracting the TEST_Duration field from the message */
	buf[numbytes] = '\0';
       test_end = atoi ( strtok(buf, " ") ); 
       
       
	printf (" Receving Start message, the test duration is %d secnods \n", test_end); 

	
	// As, we receiving START message, following frames caould be lost, so use select()
	//adding the socket to select set
	tv.tv_sec = 1;
       tv.tv_usec = 0;  /* at most waiting for 1 second */
 	
	FD_SET(sockfd, &read_fds);
	fd_max = sockfd;
	
		
	//global_num = 0;
	//alarm (1);  /* one second is basic test period plus one sec preparation timeslot */
	/* here, the sending node will going to send in 1 second, so we only wait 1 sec here */
	//signal(SIGALRM, timer_interrupt);
      	//while (!global_num){}; /* 1 sec waiting period */
	sleep(1);

	


	/* From here, every 1 sec , we have a statistics.	*/ 
	
	if ( (f1=fopen ("flow.dat", "w")) == NULL ) printf ("file open error\n");
	
	k = 0;
	//	printf ( "%c\n", strchr ("10.0.0.2", 7) );
	
	
	while (k<= test_end)
	{
	    bytes_rx_total = 0;
		    
	    	
	       /* every time before reveing packets, check the timer is due or not */
		while ( 1 )
		{ 
			tv.tv_sec = 1;
		       tv.tv_usec = 0; 
		       
			if (select(fd_max+1, &read_fds, NULL, NULL, &tv) == -1)
			{
			       printf( " Interuptted by a signal \n");
                		//perror("select");
                		//exit(1);
            		}
			// when the select fails when signal comes, we ignore it 
			
			else
			{
			/* if a packet is comming in the sockfd, then use recvfrom */
				if (FD_ISSET(fd_max, &read_fds))
				{
            			        		
 	      	         		addr_len = sizeof(struct sockaddr);
 	              		if ((numbytes=recvfrom(sockfd,buf, MAXBUFLEN-1, 0,
                               	   (struct sockaddr *)&their_addr, (socklen_t*)&addr_len)) == -1)
		        		{
 	           	       	 	perror("recvfrom");
		 	       	      exit(1);
 	      		      	       }

 	       	/* statisttical numbers for packets per sec */
				bytes_rx_total += numbytes;
			
				}
			/*otherwise, timeout when 1 second pass */
				else
				{   
		      	  	    printf("Timed out 1 sec\n");
				    fprintf ( f1, "%d %d \n" , k, bytes_rx_total);
				    break;
				    
				}
			}
	 			
		  }	    

   		
		
		//printf ("%d \n", numbytes);
		
		k++;
		
		if ( k== test_end )
		{
				
			buf[numbytes] = '\0';
  		       if ( strcmp(buf, "TEST_END") == 0 )
		       {
		            printf ("TEST_END Message Received! \n ");
		            break;

		       }
      		}
	
		
	
	 }
   
     /*
	while (strcmp(buf, "TEST_END") != 0   ) 
		{
		   
			if ((numbytes=recvfrom(sockfd,buf, MAXBUFLEN-1, 0,
                           (struct sockaddr *)&their_addr, (socklen_t*)&addr_len)) == -1)
		 	{
 	           		perror("recvfrom");
		 	           exit(1);
 	      		 }
			 buf[numbytes] = '\0';
			 
		   	  
		} 
 	*/

	printf ("TEST Time duration is due! \n ");

	fclose (f1);
       close(sockfd);
	      
       return 0;
}
