    #include <stdio.h>
    #include <stdlib.h>
    #include <unistd.h>
    #include <errno.h>
    #include <string.h>
    #include <sys/types.h>
    #include <sys/time.h>
    #include <sys/socket.h>
    #include <netinet/in.h>
    #include <arpa/inet.h>
    #include <time.h>
  
  
     #include <signal.h>

  
    #define MYPORT 4950    // the port users will be connecting to

    #define MAXBUFLEN 1500


    volatile sig_atomic_t global_num = 0; /* gloabal variable */

    void timer_interrupt(int num)
    {
                
        global_num = ! global_num; 
        alarm (1);
        signal(SIGALRM, timer_interrupt);
        //printf("Timer interrupt %d\n",m++);
     }


  
    int main(int argc, char* argv[])
    {
    
    	int bytes_rx_total;
	int rx[10];
    	int tmp;
	float rate;
	
	FILE *f1;
                             	

       int j,k, ip_addr_last;
       int sockfd;
       struct sockaddr_in my_addr;    // my address information
       struct sockaddr_in their_addr; // connector's address information
       int addr_len, numbytes;
       char buf[MAXBUFLEN]; // this is used for receiving packers
       //char signalling[20]; // this is to store START message

       char * addr_string = "10.0.0.1";
       //just initialize, no special meaning 
     	int test_end; 
	char signalling[50];
 	char ip_str[10];
	char rate_str[3];

 
       /*adding select for non-blocking purpose */
       int fd_max;
       fd_set read_fds; 
       struct timeval tv;
 
 
      //-------------------------------
 /*-----------negotiation period ---------------------------- 
	    -----------Receiving (AP) sending start signals to slaves. 1,2,3.....*/
	/* test duration is read from commmand line */
	test_end = atoi(argv[1]);  
	
	printf ( "reading configuration file %s ...... \n", argv[2]);
	        
	if ( (f1=fopen (argv[2], "r")) == NULL ) printf ("file open error\n");
	
	    
	   /* create a client socket of datagram now, 
	   the slave nodes is already running , waiting for the START message */ 
	   
	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1)
	 {
            perror("socket");
            exit(1);
        }
	
	
        their_addr.sin_family = AF_INET;     // host byte order
        their_addr.sin_port = htons(MYPORT); // short, network byte order


	
		/* getting paramters from configure file */
	
      while (1)
      {
      	 	 if ( fscanf (f1,"%s %s", ip_str, rate_str) == EOF ) break; 	
				
	 	their_addr.sin_addr.s_addr = inet_addr(ip_str);
        	memset(&(their_addr.sin_zero), '\0', 8); // zero the rest of the struct
       	
		strcpy (signalling, argv[1]);
		strcat (signalling, " ");
	 	strcat(signalling , rate_str);
		strcat (signalling , " START");
			 	
		printf ("Sending START message with %s to %s \n", signalling, ip_str);
		
  	 	if ((numbytes=sendto(sockfd, signalling, strlen(signalling), 0,
		 (struct sockaddr *)&their_addr, sizeof(struct sockaddr))) == -1)
		{
			perror("sendto");
			exit(1);
		}
		
	 
	}
	
	close (sockfd);
	fclose (f1);
	  
	 /* ------------negotiotion finished ------------------------*/

      
      
       FD_ZERO(&read_fds);   // clear the master and temp sets

	/*------Sever Started
	wait for slaves begin test-peration
	test prepare will be cost 1 sec.
	then begin receiving packets and make statistics */

        if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
            perror("socket");
            exit(1);
        }

        my_addr.sin_family = AF_INET;         // host byte order
        my_addr.sin_port = htons(MYPORT);     // short, network byte order
        my_addr.sin_addr.s_addr = INADDR_ANY; // automatically fill with my IP
        memset(&(my_addr.sin_zero), '\0', 8); // zero the rest of the struct

        if (bind(sockfd, (struct sockaddr *)&my_addr,sizeof(struct sockaddr)) == -1)
	 {
            perror("bind");
            exit(1);
        }

	printf ( " A Datagram Server is runnning on this node !\n Waiting for packets ....\n ");
	
	if ( (f1=fopen ("flow.dat", "w")) == NULL ) printf ("file open error\n"); 
	
	// As, we receiving START message, following frames caould be lost, so use select()
		//adding the socket to select set
	tv.tv_sec = 1;
       tv.tv_usec = 0;  /* at most waiting for 1 second */
 	
      
	
	FD_SET(sockfd, &read_fds);
	fd_max = sockfd;

		
	global_num = 0;
	alarm (1);  /* one second is basic test period */
	signal(SIGALRM, timer_interrupt);
     	while (!global_num){}; /* 1 sec waiting period */

	/* From here, every 1 sec , we have a statistics.	*/ 
	
	
	k = 0;
	//	printf ( "%c\n", strchr ("10.0.0.2", 7) );
	
	
	while (k<= test_end)
	{
	    for (j =0; j< 5; j++)rx[j]=0;
		    
	    tmp = global_num;
	
	       /* every time before reveing packets, check the timer is due or not */
		while ( global_num == tmp )
		{ 
				tv.tv_sec = 1;
       			tv.tv_usec = 0;  /* at most waiting for 1 second */
 	
				FD_SET(sockfd, &read_fds);
				fd_max = sockfd;

		
			if (select(fd_max+1, &read_fds, NULL, NULL, &tv) == -1)
			{
			       //printf( " Interuptted by a signal \n");
                		//perror("select");
                		//exit(1);
            		}
			// when the select fails when signal comes, we ignore it 
			
			else
			{
			/* if a packet is comming in the sockfd, then use recvfrom */
				if (FD_ISSET(fd_max, &read_fds))
				{
            			        		
 	      	         		addr_len = sizeof(struct sockaddr);
 	              		if ((numbytes=recvfrom(sockfd,buf, MAXBUFLEN-1, 0,
                               	   (struct sockaddr *)&their_addr, (socklen_t*)&addr_len)) == -1)
		        		{
 	           	       	 	perror("recvfrom");
		 	       	      exit(1);
 	      		      	       }

 	       	/* statisttical numbers for packets per sec */
				rx[0] += numbytes;
				
				addr_string =  inet_ntoa(their_addr.sin_addr) ;
				
				ip_addr_last = (unsigned int)(addr_string[strlen(addr_string)-1]) -48 ;
				 /* change CHAR in IP_addr to it's number */
		 
                            rx[ip_addr_last] += numbytes;	
			    		           			
				}
			/*otherwise, timeout when 1 second pass */
				else
				{
		      	  	    printf("Timed out 1 sec\n");
				}
			}
	 			
		  }	    

   		fprintf ( f1, "%d %d %d %d %d %d\n" , k, rx[0], rx[1],rx[2], rx[3], rx[4] ); 
		/* recording data from 4 nodes, 10.0.0.1 10.0.0.2, 10.0.0.3, 10.0.0.4 */
		
		//printf ("%d \n", numbytes);
		
		k++;
		
		if ( k== test_end )
		{
				
			buf[numbytes] = '\0';
  		       if ( strcmp(buf, "TEST_END") == 0 )
		       {
		            printf ("TEST_END Message Received! \n ");
		            break;

		       }
      		}
	
		
	
	 }
   
     /*
	while (strcmp(buf, "TEST_END") != 0   ) 
		{
		   
			if ((numbytes=recvfrom(sockfd,buf, MAXBUFLEN-1, 0,
                           (struct sockaddr *)&their_addr, (socklen_t*)&addr_len)) == -1)
		 	{
 	           		perror("recvfrom");
		 	           exit(1);
 	      		 }
			 buf[numbytes] = '\0';
			 
		   	  
		} 
 	*/

	printf ("TEST Time duration is due! \n ");

	fclose (f1);
       close(sockfd);
	      
       return 0;
}




