/* ---------------------------------------------------------------
    ******* Zhibin Wu, MOBNETS GROUP , WINLAB , ECE Rutgers U.
    ----------------------------------------------------------*/


/* tihs is the test file for MAC scheduling based on link quality */

/* basicaly,.

 it should :
 1. generate randomly sized packet
 2. create a socket with the IP address assocoiated with "eth1"
 3. send those packts with UDP


the size of the packet is uniformly distributed in (0,1500)
each time, the seed for the random number generator should be reset.

the timing issue about the packet-trans.
is a Possion distribution with 2 packets every second. Lamda = 1/2
thus, each interval between the packet is 0.5 sec.

and as the maximum length of the pkt is 1500
it requires 1500Byte/5.5Mbps  = ~2.2ms to transmit.
the time is far less than 500ms. so, the driver has enough time to handle it.

above are About packet arrival pattern and the packet size generation

However as we only generate data payload here, the length should be less than 1500.
actual maximum length is 1500 - UDP heder -IP header

*/

/*-------------------------------------------------------------

Automated Test Peocess

1. WE use one socket    sending start siganl and test packets to receiving node.
-----------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <errno.h>


#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>


#include <unistd.h>
#include <signal.h>


#include <sys/time.h>


#define MYPORT 4950    // the port users will be connecting to
#define MAXBUFLEN 1501

//#include "/usr/include/glib-1.2/glib.h"

/* new modification includes a file-reading mechinism to avoid
send seme-length packets within one second */


volatile sig_atomic_t global_num = 0; /* gloabal variable */
volatile sig_atomic_t global_num2 = 0; /* gloabal variable */

/*
void timer_interrupt(int num)
{
  global_num = ! global_num ; 
  alarm (1);
  signal(SIGALRM, timer_interrupt);
  //printf("Timer interrupt %d\n",m++);
}
*/

void timer_interrupt2(int num)
{
  global_num2 = ! global_num2 ; 
  
  //printf("Timer interrupt %d\n",m++);
}


void timer_interrupt(int num)
{
  global_num = ! global_num ; 
  
  signal(SIGALRM, timer_interrupt);
  //printf("Timer interrupt %d\n",m++);
}



int main (int argc, char* argv[])
{
	
	int test_begin, test_end, test_range, test_step;
	int i,j,k,t, tmp,tmp2, len_random;
	//float f_tim;
	int tim_int, tim_count;
	char buffer[1500];
	char buf[1501];
	int produce_max_bytes = 1500;

	 char * addr_string = "10.0.0.1";

	int stat_byte ;
	int stat_packet ;
	int sockfd;
	int addr_len;
	struct sockaddr_in my_addr; 
       struct sockaddr_in their_addr;

	/* connector's address information this is mainly composed of:
	"AF_INET" two bytes
	"port" 2bytes such as 0x8080
	"Ip address" 4 bytes as "10.0.0.57"
	final 8 bytes as all zeros!
        */
       int numbytes;
	int tb_index;
	int k0; /* how many packets should be in one second */
	int t0; /*test duration*/
	int rn_len = 10000;
	char *signalling = "TEST is going to happen!";
	//char rx_node[100];
	
	/* First reading parameter k for packets per seconds */
	/*generate a random number table, it will cost  a lot of time, because
        rand () only yiels a number per second 
           */
       /* here we assume the table is already exists in a file with 10000 numbers
       */

	//int tb [rn_len];
	int tb[10000];
	FILE * f1;	
	
       struct itimerval itimer;
       	

/*-----preparation 1: loading random numbers, open file to record data */		
	
       f1 = fopen ("rn.dat", "r");
       for (i=0; i<rn_len; i++)
       {
       	fscanf ( f1, "%d\n",tb+i);
	}
	fclose (f1);				
	
       f1 = fopen ("rn.dat", "r");
       for (i=0; i<1500; i++)
       {
       	fscanf ( f1, "%c",buffer+i);
	}
	fclose (f1);		
															

	f1 = fopen ("stat.dat","w");
	/* create a local statisitics file to know how many data are send */
	
	
/*----------------2. receing start message from Rx node ---------------*/
		/* first negotiate with master node about test parameters */
	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
            perror("socket");
            exit(1);
        }

        my_addr.sin_family = AF_INET;         // host byte order
        my_addr.sin_port = htons(MYPORT);     // short, network byte order
        my_addr.sin_addr.s_addr = INADDR_ANY; // automatically fill with my IP
        memset(&(my_addr.sin_zero), '\0', 8); // zero the rest of the struct

        if (bind(sockfd, (struct sockaddr *)&my_addr,
                         sizeof(struct sockaddr)) == -1) {
            perror("bind");
            exit(1);
        }
	
	 printf ("Test Application is beginning, waiting START signal from master node\n");
	
	 addr_len = sizeof(struct sockaddr);
        if ((numbytes=recvfrom(sockfd,buf, MAXBUFLEN-1, 0,
                           (struct sockaddr *)&their_addr, (socklen_t*)&addr_len)) == -1)
	 {
            perror("recvfrom");
            exit(1);
        }
	 
	 	 
  	 buf[numbytes] = '\0';
        //printf("packet contains \"%s\"\n",buf);
	 t0 = atoi ( strtok(buf, " ") );  
	 k =   atoi ( strtok(NULL, " ") );
	 
	 addr_string =  inet_ntoa(their_addr.sin_addr) ;
	 
	 close (sockfd);
 	
	 printf ("test duratiion is %d seconds, %d packets per second \n", t0,k);
	/*----------negitiate finished -------------------*/



/*----3.create socket again to send packets -------------------------------*/
	
	 /* this part is to create the socket */
	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1)
	 {
            perror("socket");
            exit(1);
        }

        their_addr.sin_family = AF_INET;     // host byte order
        their_addr.sin_port = htons(MYPORT); // short, network byte order
        their_addr.sin_addr.s_addr = inet_addr(addr_string);
        memset(&(their_addr.sin_zero), '\0', 8); // zero the rest of the struct

	 printf ("transmit will start soon!\n");


    
/*---------------4. Calculate the packet rate for 10ms (minimal period) ------ */
	  /* First, decide the traffic pps and timer value about ~ms */
        //k=  atoi (argv[1]);
        //the first paramter in command line is  the pps number
	 tim_count = 100;
	 k0 = k/100;
	 tim_int = 10000; //10ms is the shortest interval
	 if (k0 == 0 ) //when k < 100 pps 
	 {
	   k0 = 1;
	   tim_int = 1000000 / k;
	   tim_count = k;
	 }


 /*-----5. Preparing timer and alarm, starting 1 second timer ------*/
	
	itimer.it_interval.tv_usec = tim_int;
 	itimer.it_interval.tv_sec = 0;

 	itimer.it_value.tv_usec = tim_int;
	itimer.it_value.tv_sec = 0;

	
	
	global_num  = 0;		
	global_num2 = 0;
       alarm(1);
	signal(SIGALRM, timer_interrupt2);
	while (!global_num2){};
	 	
	setitimer(ITIMER_REAL, &itimer, NULL);	
       signal(SIGALRM, timer_interrupt);
       
 /*----------6. Sending and testing ---------------------------*/      
       
	tb_index = 0;
	
      for (t=0; t<t0; t++)
      {

 	
       stat_byte = 0 ;
       stat_packet = 0 ;

       for ( i = 0 ; i<tim_count; i++ )
       { 
 	
		tmp = global_num;
	
		for (k = 0; k<k0; k++)
		{
      			/*if timer expires , abondon the loop, it sledoms happen, becasue
			k0 is small enough  */
			if (global_num != tmp ) break;
					
			len_random  = tb[tb_index];


		//	printf (" the random packet size is %d\n ",len_random);

			if ((numbytes=sendto(sockfd, buffer, len_random, 0,
			(struct sockaddr *)&their_addr, sizeof(struct sockaddr))) == -1)
			{
				perror("sendto");
				exit(1);
			}
		
			stat_byte += len_random ;
			stat_packet++;

//	printf("sent %d bytes to %s\n", len_random, inet_ntoa(their_addr.sin_addr));
			tb_index++;
			if (tb_index == rn_len) tb_index = 0 ;
	
		}	
			
		while ( global_num == tmp ) {};
	
	} 
	//finally, 1 second eclapsed, it measure with tim_count * tim_int = 1000000 usec

       fprintf ( f1, "%d %d  %d \n", t, stat_byte, stat_packet);
                 
     }   
    
   
    signalling = "TEST_END";
    
      
    
     /* Finally, sending to inform master node that things done! */
       	if ((numbytes=sendto(sockfd, signalling, strlen(signalling), 0,
		(struct sockaddr *)&their_addr, sizeof(struct sockaddr))) == -1)
		{
			perror("sendto");
			exit(1);
		}

     
    printf ( "%s \n", signalling); 
       
    close(sockfd);
    fclose (f1);
      
return 0;

}
