/* ---------------------------------------------------------------
    ******* Zhibin Wu, MOBNETS GROUP , WINLAB , ECE Rutgers U.
    ----------------------------------------------------------*/


/* tihs is the test file for MAC scheduling based on link quality */

/* basicaly,.

 it should :
 1. generate randomly sized packet
 2. create a socket with the IP address assocoiated with "eth1"
 3. send those packts with UDP


the size of the packet is uniformly distributed in (0,1500)
each time, the seed for the random number generator should be reset.

the timing issue about the packet-trans.
is a Possion distribution with 2 packets every second. Lamda = 1/2
thus, each interval between the packet is 0.5 sec.

and as the maximum length of the pkt is 1500
it requires 1500Byte/5.5Mbps  = ~2.2ms to transmit.
the time is far less than 500ms. so, the driver has enough time to handle it.

above are About packet arrival pattern and the packet size generation

However as we only generate data payload here, the length should be less than 1500.
actual maximum length is 1500 - UDP heder -IP header

*/

/*-------------------------------------------------------------

Automated Test Peocess

1. WE use two sockers.
  One is for obtain Test parameters from Masterer Node
  the other is to sending test packets to master node.
-----------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <errno.h>


#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>


#include <unistd.h>
#include <signal.h>



#define MYPORT 4950    // the port users will be connecting to
#define MAXBUFLEN 1501

//#include "/usr/include/glib-1.2/glib.h"

/* new modification includes a file-reading mechinism to avoid
send seme-length packets within one second */


volatile sig_atomic_t global_num = 0; /* gloabal variable */
//volatile sig_atomic_t global_num2 = 0; /* gloabal variable */


void timer_interrupt(int num)
{
  global_num = ! global_num ; 
  alarm (1);
  signal(SIGALRM, timer_interrupt);
  //printf("Timer interrupt %d\n",m++);
}

/*
void timer2_interrupt(int num)
{
  global_num2 = ! global_num2 ; 
  alarm (60);
  signal(SIGALRM, timer2_interrupt);
  //printf("Timer interrupt %d\n",m++);
}
*/

int main (int argc, char* argv[])
{
	
	int test_begin, test_end, test_range, test_step;
	int i,j,k, tmp,tmp2, len_random;
	char buffer[1500];
	char buf[1501];
	int produce_max_bytes = 1500;

	int stat_byte ;
	int stat_packet ;
	int sockfd;
	int addr_len;
	struct sockaddr_in my_addr; 
       struct sockaddr_in their_addr;

	/* connector's address information this is mainly composed of:
	"AF_INET" two bytes
	"port" 2bytes such as 0x8080
	"Ip address" 4 bytes as "10.0.0.57"
	final 8 bytes as all zeros!
        */
       int numbytes;
	int tb_index;
	int k0; /* how many packets should be in one second */
	int rn_len = 10000;
	char *signalling = "TEST ALREADY FINISHED!";
	
	/* First reading parameter k for packets per seconds */
	/*generate a random number table, it will cost  a lot of time, because
        rand () only yiels a number per second 
           */
       /* here we assume the table is already exists in a file with 10000 numbers
       */

	//int tb [rn_len];
	int tb[10000];
	FILE * f1;
	
	
	/* first negotiate with master node about test parameters */
	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
            perror("socket");
            exit(1);
        }

        my_addr.sin_family = AF_INET;         // host byte order
        my_addr.sin_port = htons(MYPORT);     // short, network byte order
        my_addr.sin_addr.s_addr = INADDR_ANY; // automatically fill with my IP
        memset(&(my_addr.sin_zero), '\0', 8); // zero the rest of the struct

        if (bind(sockfd, (struct sockaddr *)&my_addr,
                         sizeof(struct sockaddr)) == -1) {
            perror("bind");
            exit(1);
        }
	
	 printf ("Test Application is beginning, waiting START signal from master node\n");
	
	 addr_len = sizeof(struct sockaddr);
        if ((numbytes=recvfrom(sockfd,buf, MAXBUFLEN-1, 0,
                           (struct sockaddr *)&their_addr, (socklen_t*)&addr_len)) == -1)
	 {
            perror("recvfrom");
            exit(1);
        }
	
  	 buf[numbytes] = '\0';
        //printf("packet contains \"%s\"\n",buf);
	 test_begin = atoi ( strtok(buf, " ") );  
	 test_end =   atoi ( strtok(NULL, " ") );
	 test_step =  atoi ( strtok(NULL, " ") );    
	 
	 close (sockfd);
 	
	 printf ("test begins with %d, ends with %d ,step is %d\n", test_begin, test_end,  test_step );
	/*----------negitiate finished -------------------*/
	
	alarm (1);
	signal(SIGALRM, timer_interrupt);
	/* setting a 1-sec timer 
	During this time, the forwarding node is to preparing the packets
	*/
	
	
       f1 = fopen ("rn.dat", "r");
       for (i=0; i<rn_len; i++)
       {
       	fscanf ( f1, "%d\n",tb+i);
	}
	fclose (f1);				
	
       f1 = fopen ("rn.dat", "r");
       for (i=0; i<1500; i++)
       {
       	fscanf ( f1, "%c",buffer+i);
	}
	fclose (f1);		
															

	f1 = fopen ("stat.dat","w");
	/* create a local statisitics file to know how many data are send */
	

	//	k0= atoi (argv[1]);
	k0 = test_begin;
	
        /* this part is to create the socket */
	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1)
	 {
            perror("socket");
            exit(1);
        }

        their_addr.sin_family = AF_INET;     // host byte order
        their_addr.sin_port = htons(MYPORT); // short, network byte order
        their_addr.sin_addr.s_addr = inet_addr("10.0.0.1");
        memset(&(their_addr.sin_zero), '\0', 8); // zero the rest of the struct


        /* waiting for the first 1 sec timer expires */
	 printf ("transmit will start soon!\n");
	  
	 while (!global_num){};
	 	

/* this part is to  send   periodically  */
//	alarm (60);
//	signal(SIGALRM, timer2_interrupt);



tb_index = 0;

while ( k0 <= test_end )
{

  //tmp2 = global_num2	;
	
  stat_byte = 0 ;
  stat_packet = 0 ;

 for ( j=0 ; j<60; j++)      /* 60 seconds as a test session */  
 {
 
 	//if (global_num2 != tmp2 ) break;

	
	tmp = global_num;
	
	for (k = 0; k<k0; k++)
	{
      		/*if timer expires , abondon the loop, it sledoms happen, becasue
		k0 is small enough  */
		if (global_num != tmp ) break;
					
			len_random  = tb[tb_index];


	//	printf (" the random packet size is %d\n ",len_random);

		//char *str= " this is a test!\n";
		if ((numbytes=sendto(sockfd, buffer, len_random, 0,
		(struct sockaddr *)&their_addr, sizeof(struct sockaddr))) == -1)
		{
			perror("sendto");
			exit(1);
		}
		
		stat_byte += len_random ;
		stat_packet++;

//	printf("sent %d bytes to %s\n", len_random, inet_ntoa(their_addr.sin_addr));

		tb_index++;
		if (tb_index == rn_len) tb_index = 0 ;
	
	}
	
	while ( global_num == tmp ) {};

}

/*	printf (" Totally send %d bytes in %d packets to %s\n", 
	        stat_byte, stat_packet,inet_ntoa(their_addr.sin_addr)  );
*/
	
      fprintf ( f1, "%d %d  %d \n", k0, stat_byte, stat_packet);
      
      k0 +=  test_step ;

      
} 
    
   /* Finally, another 1 minutes sending to inform master node that things done! */
    tmp =global_num;
    while ( tmp == global_num )
    {
    	if ((numbytes=sendto(sockfd, signalling, strlen(signalling), 0,
		(struct sockaddr *)&their_addr, sizeof(struct sockaddr))) == -1)
		{
			perror("sendto");
			exit(1);
		}

    }
     
       
      close(sockfd);
      fclose (f1);
      
	return 0;

}
